<?php
/******************************************************************************/
//                                                                            //
//                             InstantCMS v1.10.3                             //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2011                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

    if($_SERVER['HTTP_X_REQUESTED_WITH'] != 'XMLHttpRequest') { die(); }
    session_start();

    if (!isset($_REQUEST['module_id'])) { die(2); }
    if (!isset($_REQUEST['page'])) { die(4); }

    define("VALID_CMS", 1);
    define('PATH', $_SERVER['DOCUMENT_ROOT']);

    // Грузим ядро и классы
    include(PATH.'/core/cms.php');
    // Грузим конфиг
    include(PATH.'/includes/config.inc.php');
    $inCore = cmsCore::getInstance();

    define('HOST', 'http://' . $inCore->getHost());

    $inCore->loadClass('config');
    $inCore->loadClass('db');
    $inCore->loadClass('user');
    $inCore->loadClass('page');

    $inDB   = cmsDatabase::getInstance();

    setlocale(LC_ALL, 'en_US');
    // Подгружаем языковой файл
    cmsCore::loadLanguage('lang');
    cmsCore::loadLanguage('modules/mod_latestcol');

    // Входные данные
    $page        = $inCore->request('page', 'int', 1);
    $module_id    = $inCore->request('module_id', 'int', '');

    // Грузим конфиг модуля
    $cfg = $inCore->loadModuleConfig($module_id);
    // Если пагинация отключена, выходим
    if (!$cfg['is_pag']) { die(); }

function settest( $value, $default_value ){
    if ( !isset( $value ) ) { $value = $default_value; }
    return $value;
}

    // default settings
    settest( $cfg['showrss']       , 1 );
    settest( $cfg['subs']          , 1 );
    settest( $cfg['manual_ids']    , 0 );
    settest( $cfg['newscount']     , 4 );
    settest( $cfg['cat_id']        , 1 );
    settest( $cfg['in_cat_id']     , '' );
    settest( $cfg['cols']          , 2 );
    settest( $cfg['img_width']     , 64 );
    settest( $cfg['img_height']    , 64 );
    settest( $cfg['img_float']     , "left" );
    settest( $cfg['b_color']       , 'black' );
    settest( $cfg['show_img']      , 1 );
    settest( $cfg['target']        , 1 );
    settest( $cfg['title_height']  , 50 );
    settest( $cfg['title_max_char'], 50 );
    settest( $cfg['title_replacer'], "…" );
    settest( $cfg['title_style']   , "margin:0;font-weight:bold;font-size:15px;line-height:16px;color:DarkKhaki" );
    settest( $cfg['title_strict']  , 0 );
    settest( $cfg['con_height']    , 100 );
    settest( $cfg['b_margin']      , 10 );
    settest( $cfg['min_len']       , 100 );
    settest( $cfg['max_char']      , 200 );
    settest( $cfg['replacer']      , " ... " );
    settest( $cfg['strict']        , 0 );
    settest( $cfg['middle']        , 0 );
    settest( $cfg['strip_tag_text'], 0 );
    settest( $cfg['img_name']      , 'kate.png' );
    settest( $cfg['first_img']     , 1 );
    settest( $cfg['sort']          , "con.pubdate DESC" );
    settest( $cfg['is_scroll']     , 0 );
    settest( $cfg['multi']         , 10 );
    settest( $cfg['interval']      , 4000 );
    settest( $cfg['full_height']   , 250 );
    settest( $cfg['showdesc']      , 1 );
    settest( $cfg['showdate']      , 1 );
    settest( $cfg['showcom']       , 1 );
    settest( $cfg['is_pag']        , 1 );

    $cfg['img_margin'] = $cfg['img_float'] == "left" ? "right" : "left";

    $perpage    = $cfg['newscount'];


    $today = date("Y-m-d H:i:s");

if (!$cfg['manual_ids']){
    if ($cfg['cat_id'] != '-1') {
            if (!$cfg['subs']){
                //select from category
                $catsql = ' AND con.category_id = '.$cfg['cat_id'];
            } else {
                //select from category and subcategories
                $rootcat = $inDB->get_fields('cms_category', "id='{$cfg['cat_id']}'", 'NSLeft, NSRight');
                if(!$rootcat) { exit; }
                $catsql = "AND (cat.NSLeft >= {$rootcat['NSLeft']} AND cat.NSRight <= {$rootcat['NSRight']})";
            }
            $rssid = $cfg['cat_id'];

    } else { $catsql = ''; $rssid = 'all'; }
} else {
        $cat_list = array();
        foreach($cfg['in_cat_id'] as $cat_id){
            $cat_list[] = $cat_id;
        }
        $cat_list = rtrim(implode(',', $cat_list), ',');
        $catsql = ' AND con.category_id IN ('.$cat_list.')';
}

    $sql = "SELECT con.*,
                       con.pubdate as fdate,
                       u.nickname as author,
                       u.login as author_login,
                       IFNULL(r.total_rating, 0) as rating
                       FROM cms_content con
                       LEFT JOIN cms_category cat ON cat.id = con.category_id
                       LEFT JOIN cms_users u ON u.id = con.user_id
                       LEFT JOIN cms_ratings_total r ON r.item_id = con.id AND r.target='content'
                       WHERE con.published = 1 AND con.showlatest = 1 AND con.is_arhive = 0 AND con.pubdate <= '$today'
                       AND (con.is_end=0 OR (con.is_end=1 AND con.enddate >= '$today'))
                       ".$catsql."
                       ORDER BY ".$cfg['sort']."
                       LIMIT ".(($page-1)*$perpage).", $perpage";

    $result = $inDB->query($sql);

    $is_con = false;

    // Считаем общее количество материалов
    $sql_total = "SELECT 1
            FROM cms_content con
            LEFT JOIN cms_category cat ON cat.id = con.category_id
            WHERE con.published = 1 AND con.showlatest = 1 AND con.is_arhive = 0 AND con.pubdate <= '$today' AND (con.is_end=0 OR (con.is_end=1 AND con.enddate >= '$today')) ".$catsql."";
    $result_total = $inDB->query($sql_total) ;
    $total_page = $inDB->num_rows($result_total);

    // если есть записи выводим их
    if ($total_page){

        $is_con = true;

        // грузим модель компонента контент
        $inCore->loadModel('content');
        $model = new cms_model_content();

        $articles = array();
        while($con = $inDB->fetch_assoc($result)){
                $next = sizeof($articles);
                $articles[$next]['id']          = $con['id'];
                $articles[$next]['title']       = $con['title'];
                $articles[$next]['hits']        = $con['hits'];
                $articles[$next]['href']        = $model->getArticleURL(null, $con['seolink']);
                $articles[$next]['author']      = $con['author'];
                $articles[$next]['authorhref']  = cmsUser::getProfileURL($con['author_login']);
                $articles[$next]['comments']    = $cfg['showcom'] ? $inCore->getCommentsCount('article', $con['id']) : false;
                $articles[$next]['date']        = $inCore->dateformat($con['fdate']);
                $articles[$next]['rating']      = $con['rating'];
                $description = preg_replace(array('/\s+?/','/\n/','/\t/'), ' ', $con['description']);
                $content = preg_replace(array('/\s+?/','/\n/','/\t/'), ' ', $con['content']);
                $inCore->processFilters($con['description']);
                $inCore->processFilters($con['content']);

                $articles[$next]['description'] = strlen(strip_tags($description)) > $cfg['min_len'] ? $description : $content;

                if ($cfg['first_img']){
                    $in_desc = preg_match('/<img\s?[^>]*?\s?src="(.*?)"\s?[^>]*?\s?\/>/is', $con['description'], $matches);
                    if (!$in_desc) { preg_match('/<img\s?[^>]*?\s?src="(.*?)"\s?[^>]*?\s?\/>/is', $con['content'], $matches); }
                    if ($matches[1]){
                        $test_out = $matches[1];
                        if (preg_match('/http|https/', $test_out)){
                            $law_img = imagecreatefromstring(file_get_contents($test_out));
                            if ($law_img) {
                                $articles[$next]['first_image'] = $test_out;
                            }
                        }
                        else if (file_exists(PATH.$matches[1])) {
                            $articles[$next]['first_image'] = $matches[1];
                        }
                    } else {
                        $articles[$next]['first_image'] = (file_exists(PATH.'/images/photos/small/article'.$con['id'].'.jpg') ? '/images/photos/small/article'.$con['id'].'.jpg' : '');
                    }
                } else {
                    $articles[$next]['image'] = (file_exists(PATH.'/images/photos/small/article'.$con['id'].'.jpg') ? 'article'.$con['id'].'.jpg' : '');
                }
        }
    }

    // Отдаем в шаблон
    ob_start();
        $pagebar = $cfg['is_pag'] ? cmsPage::getPagebar($total_page, $page, $perpage, 'javascript:conPageCol(%page%, '.$module_id.')') : '';

        cmsPage::initTemplate('modules', 'mod_latestcol')->
            assign('articles', $articles)->
            assign('rssid', $rssid)->
            assign('is_con', $is_con)->
            assign('is_ajax', false)->
            assign('pagebar_module', $pagebar)->
            assign('module_id', $module_id)->
            assign('cfg', $cfg)->
            display('mod_latestcol.tpl');
    $html = ob_get_clean();
    echo $html;

?>
